void drawOthello(){
  background(0, 255, 0);
  for (int x=0; x<8; x++) {
    for (int y=0; y<8; y++) {
      stroke(0);
      fill(0, 255, 0);
      rect(x*100, y*100, 100, 100);
      if (units[x][y] == 1) {
        fill(255);
        ellipse(x*100+50, y*100+50, 80, 80);
      } else if (units[x][y] == 2) {
        fill(0);
        ellipse(x*100+50, y*100+50, 80, 80);
      }
    }
  }
}

void initOthello()
{
  for (int x=0; x<8; x++)
    for (int y=0; y<8; y++)
      units[x][y] = 0;
  units[3][3] = 1;
  units[3][4] = 2;
  units[4][3] = 2;
  units[4][4] = 1;
}

void setUnit( int id, int x, int y ) {
  // 変な値が来たら無視する
  if ( x < 0 || x >= 8 || y < 0 || y >= 8 ) return;

  // 周辺の探索
  units[x][y] = id;
  for ( int i=-1; i<=1; i++ ) {
    for ( int j=-1; j<=1; j++ ) {
      if ( i==0 && j==0 ) {
      } else {
        isHit( id, x, y, i, j );
      }
    }
  }
}

boolean isHit( int id, int x, int y, int dx, int dy ) {
  x += dx;
  y += dy;
  
  if ( x < 0 || x >= 8 || y < 0 || y >= 8 ) { 
    return false;
  }
  if ( units[x][y] == 0 ) { 
    return false;
  }
  if ( units[x][y] == id ) { 
    return true;
  }
  
  boolean bRet = isHit( id, x, y, dx, dy );
  if ( bRet == true ) {
    units[x][y] = id;
  }
  return bRet;
}
